# matrix-appservice-kakaotalk - A Matrix-KakaoTalk puppeting bridge.
# Copyright (C) 2022 Tulir Asokan, Andrew Ferrazzutti
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.
from typing import Optional

from attr import dataclass

from ...bson import Long
from . import Attachment
from ..chat_type import ChatType
from .mention import MentionStruct


@dataclass(kw_only=True)
class ReplyAttachment(Attachment):
    attach_only: bool = None # NOTE Made optional
    attach_type: Optional[ChatType] = None # NOTE Changed from int for outgoing typeless replies
    src_linkId: Optional[Long] = None
    src_logId: Long
    src_mentions: list[MentionStruct] = None # NOTE Made optional
    src_message: str
    src_type: ChatType
    src_userId: Long


__all__ = [
    "ReplyAttachment",
]
